package lcsb.mapviewer.converter.model.celldesigner;

import java.io.IOException;
import java.nio.file.*;
import java.util.ArrayList;
import java.util.Collection;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.*;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import lcsb.mapviewer.converter.ConverterParams;
import lcsb.mapviewer.model.map.model.Model;
import lcsb.mapviewer.model.map.model.ModelComparator;

@RunWith(Parameterized.class)
public class CellDesignerParserForCD2_5Test extends CellDesignerTestFunctions {
  Logger logger = LogManager.getLogger();

  ModelComparator modelComparator = new ModelComparator();

  private Path filePath;

  public CellDesignerParserForCD2_5Test(Path filePath) {
    this.filePath = filePath;
  }

  @Parameters(name = "{index} : {0}")
  public static Collection<Object[]> data() throws IOException {
    Collection<Object[]> data = new ArrayList<Object[]>();
    Files.walk(Paths.get("testFiles/cd_2.5")).forEach(fPath -> {
      if (Files.isRegularFile(fPath)) {
        data.add(new Object[] { fPath });
      }
    });
    return data;
  }

  @Before
  public void setUp() throws Exception {
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testSerialization() throws Exception {
    CellDesignerXmlParser parser = new CellDesignerXmlParser();
    Model model = parser.createModel(new ConverterParams().filename(filePath.toString()).sizeAutoAdjust(false));

    testXmlSerialization(model);
  }
}
