package lcsb.mapviewer.converter.model.sbgnml;

import org.sbgn.bindings.Arc;
import org.sbgn.bindings.Glyph;

import lcsb.mapviewer.converter.model.sbgnml.structures.Process;
import lcsb.mapviewer.model.LogMarker;
import lcsb.mapviewer.model.ProjectLogEntryType;
import lcsb.mapviewer.model.map.model.Model;

public class SbgnLogMarker extends LogMarker {

  /**
   * 
   */
  private static final long serialVersionUID = 1L;

  public SbgnLogMarker(LogMarker marker) {
    super(marker);
  }

  public SbgnLogMarker(ProjectLogEntryType type, Arc arc, Model model) {
    super(type, arc.getClazz(), arc.getId(), model.getName());
  }

  public SbgnLogMarker(ProjectLogEntryType type, Glyph glyph, Model model) {
    super(type, glyph.getClazz(), glyph.getId(), model.getName());
  }

  public SbgnLogMarker(ProjectLogEntryType type, Process p, Model model) {
    super(type, "PROCESS", p.getCentralPoint().getId(), model.getName());
  }

}
