package lcsb.mapviewer.converter.model.sbml;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.sbml.jsbml.Parameter;

import lcsb.mapviewer.model.map.kinetics.SbmlParameter;
import lcsb.mapviewer.model.map.model.Model;

public class SbmlParameterExporter {
  Logger logger = LogManager.getLogger();
  
  private Model minervaModel;

  public SbmlParameterExporter(lcsb.mapviewer.model.map.model.Model minervaModel) {
    this.minervaModel = minervaModel;
  }

  public void exportParameter(org.sbml.jsbml.Model result) {
    for (SbmlParameter parameter : minervaModel.getParameters()) {
      result.addParameter(createParameter(parameter));
    }
  }

  private Parameter createParameter(SbmlParameter parameter) {
    Parameter result = new Parameter();
    result.setName(parameter.getName());
    result.setValue(parameter.getValue());
    result.setId(parameter.getParameterId());
    if (parameter.getUnits() != null) {
      result.setUnits(parameter.getUnits().getUnitId());
    }
    result.setConstant(true);
    return result;
  }

}
