package lcsb.mapviewer.persist.dao.map.kinetics;

import java.util.List;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import lcsb.mapviewer.model.Project;
import lcsb.mapviewer.model.map.kinetics.SbmlFunction;
import lcsb.mapviewer.model.map.model.ModelData;
import lcsb.mapviewer.persist.dao.BaseDao;

@Transactional
@Service
public class SbmlFunctionDao extends BaseDao<SbmlFunction> {

  public SbmlFunctionDao() {
    super(SbmlFunction.class);
  }

  public List<SbmlFunction> getByProject(Project project) {
    @SuppressWarnings("unchecked")
    List<SbmlFunction> list = getSession()
        .createQuery(
            "select reaction_t from " + getClazz().getSimpleName()
                + " reaction_t join reaction_t.model.project project_t where project_t.projectId = :project_id order by reaction_t.id desc")
        .setParameter("project_id", project.getProjectId()).list();
    return list;
  }

  public SbmlFunction getById(int id, ModelData map) {
    List<?> list = getSession()
        .createQuery(
            " from " + this.getClazz().getSimpleName() + " where id=:id and model = :map" + removableAndStatemant())
        .setParameter("id", id)
        .setParameter("map", map)
        .list();
    if (list.size() == 0) {
      return null;
    } else {
      return (SbmlFunction) list.get(0);
    }
  }

}
