package lcsb.mapviewer.persist.dao.map.kinetics;

import java.util.List;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import lcsb.mapviewer.model.map.kinetics.SbmlParameter;
import lcsb.mapviewer.model.map.model.ModelData;
import lcsb.mapviewer.persist.dao.BaseDao;

@Transactional
@Service
public class SbmlParameterDao extends BaseDao<SbmlParameter> {

  public SbmlParameterDao() {
    super(SbmlParameter.class);
  }

  public List<SbmlParameter> getByMaps(List<ModelData> maps) {
    @SuppressWarnings("unchecked")
    List<SbmlParameter> list = getSession()
        .createQuery(
            "select parameter_t from " + ModelData.class.getSimpleName()
                + " model inner join model.parameters parameter_t "
                + " where model in :maps order by parameter_t.id")
        .setParameter("maps", maps).list();
    return list;
  }

  public SbmlParameter getById(int id, ModelData map) {
    List<?> list = getSession()
        .createQuery(
            "select parameter_t from " + ModelData.class.getSimpleName()
                + " model inner join model.parameters parameter_t "
                + " where model = :map")
        .setParameter("map", map).list();
    if (list.size() == 0) {
      return null;
    } else {
      return (SbmlParameter) list.get(0);
    }
  }

}
