package lcsb.mapviewer.persist.dao.map.kinetics;

import java.util.List;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import lcsb.mapviewer.model.map.kinetics.SbmlUnit;
import lcsb.mapviewer.model.map.model.ModelData;
import lcsb.mapviewer.persist.dao.BaseDao;

@Transactional
@Service
public class SbmlUnitDao extends BaseDao<SbmlUnit> {

  public SbmlUnitDao() {
    super(SbmlUnit.class);
  }

  public List<SbmlUnit> getByMaps(List<ModelData> maps) {
    @SuppressWarnings("unchecked")
    List<SbmlUnit> list = getSession()
        .createQuery(
            "select unit_t from " + ModelData.class.getSimpleName()
                + " model inner join model.units unit_t "
                + " where model in :maps order by unit_t.id")
        .setParameter("maps", maps).list();
    return list;
  }

  public SbmlUnit getById(int id, ModelData map) {
    List<?> list = getSession()
        .createQuery(
            "select unit_t from " + ModelData.class.getSimpleName()
                + " model inner join model.units unit_t "
                + " where model = :map")
        .setParameter("map", map).list();
    if (list.size() == 0) {
      return null;
    } else {
      return (SbmlUnit) list.get(0);
    }
  }

}
