package lcsb.mapviewer.persist.dao.map.kinetics;

import static org.junit.Assert.assertEquals;

import java.util.Arrays;
import java.util.List;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import lcsb.mapviewer.model.map.kinetics.SbmlUnit;
import lcsb.mapviewer.model.map.model.Model;
import lcsb.mapviewer.model.map.model.ModelFullIndexed;
import lcsb.mapviewer.persist.PersistTestFunctions;
import lcsb.mapviewer.persist.dao.map.ModelDao;

public class SbmlUnitDaoTest extends PersistTestFunctions {

  @Autowired
  ModelDao modelDao;
  
  @Autowired
  SbmlUnitDao sbmlUnitDao;

  @Test
  public void testGetByMaps() {
    Model model = new ModelFullIndexed(null);
    SbmlUnit unit = new SbmlUnit("id");
    model.addUnit(unit);

    modelDao.add(model);
    
    List<SbmlUnit> parameters = sbmlUnitDao.getByMaps(Arrays.asList(model.getModelData()));
    assertEquals(1, parameters.size());
  }

  @Test
  public void testGetById() {
    Model model = new ModelFullIndexed(null);
    SbmlUnit unit = new SbmlUnit("id");
    model.addUnit(unit);

    modelDao.add(model);
    
    SbmlUnit result = sbmlUnitDao.getById(unit.getId(), model.getModelData());
    assertEquals(unit, result);
  }

}
