package lcsb.mapviewer.persist.dao.map.layout.alias;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.*;
import org.springframework.beans.factory.annotation.Autowired;

import lcsb.mapviewer.model.map.model.Model;
import lcsb.mapviewer.model.map.model.ModelFullIndexed;
import lcsb.mapviewer.model.map.species.Element;
import lcsb.mapviewer.model.map.species.Protein;
import lcsb.mapviewer.model.map.species.field.Residue;
import lcsb.mapviewer.persist.DbUtils;
import lcsb.mapviewer.persist.PersistTestFunctionsNoTransaction;
import lcsb.mapviewer.persist.dao.map.ModelDao;
import lcsb.mapviewer.persist.dao.map.species.ElementDao;

public class ElementDaoTestSeparateTransaction extends PersistTestFunctionsNoTransaction {
  @SuppressWarnings("unused")
  private Logger logger = LogManager.getLogger();

  @Autowired
  private ElementDao elementDao;

  @Autowired
  private ModelDao modelDao;

  @Autowired
  private DbUtils dbUtils;

  @Before
  public void setUp() throws Exception {
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testSearchClosestWithModifications() throws Exception {
    Model map = new ModelFullIndexed(null);
    Protein protein = createProtein(645.0, 220.5, 70.0, 25.0, "sa1");
    protein.addResidue(new Residue());
    map.addElement(protein);
    map.addElement(createProtein(645.0, 120.5, 70.0, 25.0, "sa2"));

    dbUtils.createSessionForCurrentThread();
    modelDao.add(map);
    dbUtils.closeSessionForCurrentThread();

    dbUtils.createSessionForCurrentThread();
    List<Element> elements = elementDao.getByCoordinates(map.getModelData(), new Point2D.Double(12, 4.5), 5,
        new ArrayList<>());
    dbUtils.closeSessionForCurrentThread();

    assertNotNull(elements);
    assertEquals(2, elements.size());
    assertEquals("sa2", elements.get(0).getElementId());

  }

}
