package lcsb.mapviewer.api.projects.chemicals;

import static org.junit.Assert.assertNotNull;

import java.util.Map;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.*;
import org.springframework.beans.factory.annotation.Autowired;

import lcsb.mapviewer.annotation.data.Chemical;
import lcsb.mapviewer.api.RestTestFunctions;
import lcsb.mapviewer.model.Project;
import lcsb.mapviewer.model.map.MiriamData;
import lcsb.mapviewer.model.map.MiriamType;

public class ChemicalRestImplTest extends RestTestFunctions {
  Logger logger = LogManager.getLogger();

  @Autowired
  private ChemicalRestImpl _drugRestImpl;

  @AfterClass
  public static void tearDownAfterClass() throws Exception {
  }

  @Before
  public void setUp() throws Exception {
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testPrepareChemical() throws Exception {
    Chemical chemical = new Chemical();
    chemical.setChemicalId(new MiriamData(MiriamType.MESH_2012, "D010300"));
    Map<String, Object> result = _drugRestImpl.prepareChemical(chemical, _drugRestImpl.createChemicalColumnSet(""),
        new Project());
    assertNotNull(result);
  }

  @Test
  public void testPrepareChemicalWithProblematicMesh() throws Exception {
    Chemical chemical = new Chemical();
    chemical.setChemicalId(new MiriamData(MiriamType.MESH_2012, "invalidID"));

    Map<String, Object> result = _drugRestImpl.prepareChemical(chemical, _drugRestImpl.createChemicalColumnSet(""),
        new Project());
    assertNotNull(result);
  }

}
