package lcsb.mapviewer.api.projects.mirnas;

import static org.junit.Assert.assertFalse;

import java.util.*;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.*;
import org.springframework.beans.factory.annotation.Autowired;

import lcsb.mapviewer.api.RestTestFunctions;
import lcsb.mapviewer.model.Project;
import lcsb.mapviewer.model.map.model.Model;
import lcsb.mapviewer.persist.dao.ProjectDao;

public class MiRnaRestImplTest extends RestTestFunctions {
  Logger logger = LogManager.getLogger();

  @Autowired
  MiRnaRestImpl miRnaRestImpl;

  @Autowired
  ProjectDao projectDao;

  @AfterClass
  public static void tearDownAfterClass() throws Exception {
  }

  @Before
  public void setUp() throws Exception {
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testGetMiRnasByTarget() throws Exception {
    Model model = getModelForFile("testFiles/model/mi_rna_target.xml", false);
    Project project = new Project("mi_rna_target");
    project.setOwner(userService.getUserByLogin(ADMIN_BUILT_IN_LOGIN));
    project.addModel(model);
    projectDao.add(project);
    List<Map<String, Object>> result = miRnaRestImpl.getMiRnasByTarget(project.getProjectId(), "ALIAS",
        model.getSpeciesList().get(0).getId() + "", "");
    Set<String> names = new HashSet<>();
    for (Map<String, Object> miRna : result) {
      assertFalse("Duplicate miRna found: " + miRna.get("name"), names.contains(miRna.get("name")));
      names.add((String) miRna.get("name"));
    }
  }

}
