package lcsb.mapviewer.api.projects.models.bioEntities;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.awt.geom.Point2D;
import java.util.List;
import java.util.Map;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.*;
import org.springframework.beans.factory.annotation.Autowired;

import com.fasterxml.jackson.databind.ObjectMapper;

import lcsb.mapviewer.api.RestTestFunctions;
import lcsb.mapviewer.model.Project;
import lcsb.mapviewer.model.map.model.Model;
import lcsb.mapviewer.persist.dao.ProjectDao;

public class BioEntitiesControllerTest extends RestTestFunctions {
  Logger logger = LogManager.getLogger();

  @Autowired
  BioEntitiesRestImpl _bioEntitiesRestImpl;

  ObjectMapper mapper = new ObjectMapper();

  @Autowired
  ProjectDao projectDao;
  
  Model model;

  @AfterClass
  public static void tearDownAfterClass() throws Exception {
  }

  @Before
  public void setUp() throws Exception {
    model = super.getModelForFile("testFiles/model/sample.xml", false);
    Project project = new Project(model.getName());
    project.setOwner(userService.getUserByLogin(ADMIN_BUILT_IN_LOGIN));
    project.addModel(model);
    projectDao.add(project);
  }
  

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testGetClosestElementsByCoordinates() throws Exception {
    int count = 3;
    List<Map<String, Object>> result = _bioEntitiesRestImpl.getClosestElementsByCoordinates("sample", ""+model.getId(),
        new Point2D.Double(1, 2), count, "false", "");
    assertEquals(count, result.size());

    String json = mapper.writeValueAsString(result);
    assertNotNull(json);
  }

}
