package lcsb.mapviewer.services.interfaces;

import java.util.List;
import java.util.Map;

import lcsb.mapviewer.model.map.MiriamType;
import lcsb.mapviewer.model.map.species.Element;
import lcsb.mapviewer.persist.dao.map.species.ElementProperty;
import lcsb.mapviewer.services.ObjectNotFoundException;
import lcsb.mapviewer.services.QueryException;

public interface IElementService {

  Element getById(int id);

  Element getElementById(String projectId, int elementId) throws ObjectNotFoundException;

  Element getElementById(String projectId, int mapId, int elementId) throws QueryException;

  List<Element> getElementsByFilter(Map<ElementProperty, List<? extends Object>> properties);

  Map<MiriamType, Integer> getAnnotationStatistics(String projectId, String mapId) throws QueryException;

}
