package lcsb.mapviewer.services.interfaces;

import java.io.IOException;
import java.util.List;

import lcsb.mapviewer.model.Project;
import lcsb.mapviewer.model.map.layout.ProjectBackground;
import lcsb.mapviewer.model.user.User;
import lcsb.mapviewer.services.ObjectNotFoundException;
import lcsb.mapviewer.services.utils.EmailSender;

/**
 * Service that manages layouts of the map.
 *
 * @author Piotr Gawron
 *
 */
public interface IProjectBackgroundService {

  void removeProjectBackground(ProjectBackground background, String homeDir) throws IOException;

  void updateProjectBackground(ProjectBackground background);

  EmailSender getEmailSender();

  void setEmailSender(EmailSender emailSender);

  List<ProjectBackground> getProjectBackgroundsByProject(Project project);

  List<ProjectBackground> getProjectBackgroundsByProject(String projectId);

  ProjectBackground getProjectBackgroundById(Integer backgroundId);
  
  ProjectBackground getProjectBackgroundById(String projectId, Integer backgroundId) throws ObjectNotFoundException;

  List<ProjectBackground> getProjectBackgroundsByUser(User user);

}
