package lcsb.mapviewer.services.interfaces;

import java.util.*;

import org.springframework.data.domain.Page;

import lcsb.mapviewer.model.map.MiriamType;
import lcsb.mapviewer.model.map.kinetics.SbmlParameter;
import lcsb.mapviewer.model.map.reaction.Reaction;
import lcsb.mapviewer.persist.dao.map.ReactionProperty;
import lcsb.mapviewer.services.QueryException;

public interface IReactionService {

  Reaction getReactionById(String projectId, int mapId, int elementId) throws QueryException;

  Reaction getById(int id);

  List<Reaction> getReactionById(String projectId, String modelId, Set<Integer> ids, Set<Integer> participantIds)
      throws QueryException;

  List<SbmlParameter> getParameters(String projectId, String modelId) throws QueryException;

  Map<MiriamType, Integer> getAnnotationStatistics(String projectId, String mapId) throws QueryException;

  Page<Reaction> getReactionsByFilter(Map<ReactionProperty, List<? extends Object>> reactionSearch);

}
