package lcsb.mapviewer.web;

import static org.springframework.restdocs.mockmvc.MockMvcRestDocumentation.document;
import static org.springframework.restdocs.mockmvc.RestDocumentationRequestBuilders.get;
import static org.springframework.restdocs.payload.PayloadDocumentation.fieldWithPath;
import static org.springframework.restdocs.payload.PayloadDocumentation.responseFields;
import static org.springframework.restdocs.request.RequestDocumentation.parameterWithName;
import static org.springframework.restdocs.request.RequestDocumentation.pathParameters;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.*;
import org.junit.runner.RunWith;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.web.servlet.RequestBuilder;

@RunWith(SpringJUnit4ClassRunner.class)
public class MeshControllerIntegrationTest extends ControllerIntegrationTest {

  Logger logger = LogManager.getLogger();

  @Before
  public void setup() {
  }

  @After
  public void tearDown() {
  }

  @Test
  public void testGetTaxonomies() throws Exception {

    RequestBuilder request = get("/mesh/{meshId}", "D002095");

    mockMvc.perform(request)
        .andDo(document("mesh/get_mesh",
            pathParameters(parameterWithName("meshId").description("mesh id")),
            responseFields(
                fieldWithPath("name")
                    .description("name")
                    .type("string"),
                fieldWithPath("description")
                    .description("description")
                    .type("string"),
                fieldWithPath("synonyms")
                    .description("list of synonyms")
                    .type("array"),
                fieldWithPath("id")
                    .description("mesh id")
                    .type("string"))))
        .andExpect(status().is2xxSuccessful());
  }

}
