package lcsb.mapviewer.web;

import org.mockito.Mockito;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.*;

import lcsb.mapviewer.annotation.services.dapi.*;

@Profile("webCtdTestProfile")
@Configuration
public class WebCtdDapiConfiguration {

  @Autowired
  private DapiConnector dapiConnector;

  private String dapiLogin;
  private String dapiPassword;

  public WebCtdDapiConfiguration() {
    dapiLogin = System.getenv("DAPI_TEST_LOGIN");
    dapiPassword = System.getenv("DAPI_TEST_PASSWORD");
  }

  @Bean
  @Primary
  public DapiConnector dapiConnector() throws DapiConnectionException {
    DapiConnectorImpl mock = (DapiConnectorImpl) Mockito.spy(dapiConnector);

    Mockito.doReturn(true).when(mock).isValidConnection();

    Mockito.doReturn(dapiLogin).when(mock).getDapiLogin();
    Mockito.doReturn(dapiPassword).when(mock).getDapiPassword();
    return mock;
  }

}
